/*
 * Copyright (c) 2002, Peter Bentley
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 *   Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 *   Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * 
 *   The name Peter Bentley may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: omd_time.h,v 1.6 2002/11/07 09:09:12 pete Exp $
 *
 * ** omd_time.h - Time stuff
 */

typedef struct {
    uint16	minutes;
    uint16	seconds;
    uint16	frames;		/* Not sure is this is frames or centis */
} omd_time_t;

/* Convert a 4 byte BCD array as returned via NetMD */
int omd_time_from_bytes( omd_time_t *t, uint8 *data );
uint32 omd_time_to_bcd( omd_time_t *t );

void omd_time_from_double( omd_time_t *t, double val );
double omd_time_to_double( omd_time_t *t );
char *omd_time_to_string( omd_time_t *t, char *buffer );
void omd_time_add( omd_time_t *to, omd_time_t *amt );
int omd_time_from_string( omd_time_t *t, const char *str );
uint32 omd_time_to_bcd( omd_time_t *t );

#define omd_time_zero( x ) omd_time_from_double( (x), 0.0 )
